<?php

namespace HCM\FPA\Calculos\Geral;

use HCM\Util\DateUtil;
use HCM\Util\Repositories;
use HCM\FPA\Entity\FpafaixatabelaEntity;
use HCM\FPA\Entity\FpatabelafolhaEntity;
use HCM\FPA\Entity\FpaValorreferenciam;
use HCM\FPA\Entity\FpaeventohEntity;

class SalarioFamilia {

    public function calcula(
        $incidencia, $evento, $mes_competencia, $item_de_calculo,
        $assoc_eventos, $eventom, $vinculo,
        $dias_normais, $salario_base, $entityManager
    ){
        $num_dependentes = $vinculo->historico->getNrdependsfam();
        $base = $item_de_calculo->calculaIncidencias($incidencia, $mes_competencia, $eventom);

        $referencia = 0;
        
        $verificadireito = FpafaixatabelaEntity::retornaValorProcessado(
            $salario_base, FpatabelafolhaEntity::TAB_SALARIO_FAMILIA,$mes_competencia, $referencia
        );

        $cota = FpafaixatabelaEntity::retornaValorProcessado(
            $base, FpatabelafolhaEntity::TAB_SALARIO_FAMILIA, $mes_competencia, $referencia
        );
        
         if ($verificadireito==0){
            $cota=0.0;
        } else {
            if ($cota>$verificadireito){
                $cota=$verificadireito;
            }
        }
        $sal_familia = $cota * $num_dependentes;
        $calculoEvento = $cota.' (cota) * '.$num_dependentes.' (Nº dependentes) = '.$sal_familia;
        $PropSalFamilia = $entityManager->getRepository(Repositories::FPA_VALORREFERENCIAM)->buscavalor($vinculo->getNrorg(), 0, $mes_competencia, 'ID_PROP_SAL_FAMILIA');
        
        
        if($PropSalFamilia == 1){
            $sal_familia = ($cota/30*$dias_normais) * $num_dependentes;
            $calculoEvento = $cota.' (cota) / 30 * '.$dias_normais.' (Dias Mes) * '.$num_dependentes.'(Nº dependentes) = '.$sal_familia;
        }
        $nrevento =  $assoc_eventos->retornaEvento($evento, $vinculo->getNrorg());
        $evento_sal_familia = $eventom->retornaEvento($nrevento);

        if ($evento_sal_familia->historico->getIdunidrefereven() === FpaeventohEntity::IDUNIDREFEREVEN_COTA) {
            $referencia = $num_dependentes;
        }
        
        MemoriaCalculo::getInstance()->escreveEventos($item_de_calculo->getNrcalculofolha(),$evento_sal_familia,$calculoEvento,$mes_competencia,$sal_familia,$referencia,null,$cota,null,100);
        $item_de_calculo->geraEvento(
            $evento_sal_familia, null, $sal_familia, $referencia, 1
        );
    }


}