-- ====================================================================
--                  Procedimento para Zerar Implantao
--                  ------------ ---- ----- -----------
--
--  Parmetros: P_Filial     = Cdigo da filial a ser considerada.
--  ----------  P_NrLancto   = Nmero de um lanamento.
--              P_DtImplant  = Data da implantao de estoque.
--
--   Convertido para SQL - SERVER POR ROBERT
-- ================================================================================
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE 
	        O.NAME = 'ZERA_IMPLANTACAO'  AND 
	        TYPE = 'P' 			        AND
	        U.UID = O.UID             		        AND 
	        U.NAME = USER)

  DROP PROCEDURE ZERA_IMPLANTACAO
  GO


CREATE PROCEDURE ZERA_IMPLANTACAO @P_Filial    VARCHAR(4),
 				                      @P_NrLancto  VARCHAR(10),
                                  @P_DtImplant DATETIME,
                                  @P_SequItem  NUMERIC OUTPUT

AS

   DECLARE @V_SEQUITEM  VARCHAR(4);
   DECLARE @V_PRODUTO   VARCHAR(10);
   DECLARE @V_DTPOSICAO DATETIME;

BEGIN


   DECLARE C_PRODZERA CURSOR FOR
   SELECT CDPRODUTO, MAX(DTPOSIESTQ) AS DTPOSIESTQ
   FROM POSESTDIA
   WHERE (CDFILIAL    = @P_FILIAL)    AND
         (DTPOSIESTQ <= @P_DTIMPLANT) AND
         (QTESTOQDIA <> 0)            AND
          NOT (CDPRODUTO IN (SELECT CDPRODMOVI
                             FROM ITLANCTOEST
                             WHERE (CDFILIAL   = @P_FILIAL) AND
                                   (NRLANCESTQ = @P_NRLANCTO)))
   GROUP BY CDPRODUTO;


   /* Ler os Produtos que sero atualizados  */

   OPEN C_PRODZERA;

   FETCH NEXT FROM C_PRODZERA INTO @V_PRODUTO, @V_DTPOSICAO;

   WHILE (@@FETCH_STATUS = 0)
   BEGIN

      SET @P_SequItem = @P_SequItem + 1;
      SET @V_SEQUITEM = RIGHT(REPLICATE('0',4) + RTRIM(CONVERT(VARCHAR, @P_SequItem) + '0001'),4);

      INSERT INTO ITLANCTOEST (CDFILIAL , NRLANCESTQ, NRSEQUITEM, CDPRODUTO , QTTOTLANCTO, VRUNILANCTO, VRTOTLANCTO, DTLANCMOVI  , IDORDEMCLC, IDTIPOMOVI, CDPRODMOVI , QTLANCTOEST, VRLANCTOEST)
                       VALUES (@P_Filial , @P_NrLancto, @V_SEQUITEM, @V_PRODUTO , 0          , 0          , 0          , @P_DtImplant , '0'       , '0'       , @V_PRODUTO  , 0          , 0          );

      FETCH NEXT FROM C_PRODZERA INTO @V_PRODUTO, @V_DTPOSICAO;

   END;
   CLOSE C_PRODZERA;
   DEALLOCATE C_PRODZERA;
END;
GO

--  Select CdProduto, Max(DtPosiEstq) as DtPosiEstq
--  From POSESTDIA
--  Where (CdFilial    = &P_Filial)    AND
--        (DtPosiEstq <= &P_DtImplant) AND
--        (QtEstoqDia <> 0)            AND
--         not (CdProduto in (Select CdProdMovi
--                            From ITLANCTOEST
--                            Where (CdFilial   = &P_Filial) and
--                                  (NrLancEstq = &P_NrLancto)))
--  group by CdProduto;
--  '0001'
--  '11/05/98'
--  '0001'
--  '0000000001'


-- SELECT CdProduto, QtEstoqDia, VrEstoqDia
-- FROM POSESTDIA A, (Select Max(DtPosiEstq) as DtPosiEstq, CdProduto as CdProdData
--                    From POSESTDIA
--                    Where (CdFilial    = &P_Filial) and
--                          (DtPosiEstq <= &P_DtPosiEstq)
--                    group by CdProduto) B
-- WHERE (A.CdFilial    = &P_Filial)    AND
--       (A.CdProduto   = B.CdProdData) AND
--       (A.DtPosiEstq  = B.DtPosiEstq) AND
--       (A.QtEstoqDia <> 0)            AND
--        not (A.CdProduto in (Select CdProdMovi
--                             From ITLANCTOEST
--                             Where (CdFilial   = &P_Filial) and
--                                   (NrLancEstq = &P_Lancto)))


-- SELECT CdProduto
-- FROM POSESTDIA A
-- WHERE (A.CdFilial    = &P_Filial) AND
--       (A.DtPosiEstq  = (Select Max(DtPosiEstq)
--                         From POSESTDIA
--                         Where (CdFilial    = &P_Filial)   and
--                               (CdProduto   = A.CdProduto) and
--                               (DtPosiEstq <= &P_DtImplant))) AND
--       (A.QtEstoqDia <> 0)            AND
--        not (A.CdProduto in (Select CdProdMovi
--                             From ITLANCTOEST
--                             Where (CdFilial   = &P_Filial) and
--                                   (NrLancEstq = &P_NrLancto)));

